require 'spec_helper' 
require 'klassy'

describe Klassy do
  def test_run
    Klassy.klassify do
      first_class(name: "bob") do
        second_class(color: "green", answer: 42) do
          third_class
        end
        second_class(sky: "blue")
      end
    end
  end

  #subject(:result_object) { test_run }
  before(:all) { @result_object = test_run }

  describe "::klassify" do
    it "should create classes" do
      # @result_object.should be_an_instance_of(Klassy::FirstClass)
      @result_object.class.name.should eq("Klassy::FirstClass")
    end

    it "should create children recursively" do
      @result_object.second_class.first.should
                                          be_an_instance_of(Klassy::SecondClass)
      @result_object.second_class.first.third_class.first.should
                                           be_an_instance_of(Klassy::ThirdClass)
      @result_object.second_class.count.should eq(2)
    end

    it "should create attributes dynamically" do
      @result_object.name.should eq("bob")
      @result_object.second_class.first.color.should eq("green")
      @result_object.second_class.first.answer.should eq(42)
      @result_object.second_class.last.sky.should eq("blue")
    end

  end

  describe "resulting object" do
    it "should respond to #children" do
      @result_object.should respond_to(:second_class)
    end

  end
end
